% MATLAB_TOOLS: a collection of small tools for use in MATLAB
%
% Files
%   gipper       - zip selected files and subdirectories (gipper = grep + zip)
%   hprintf      - fprintf with hypertext links not highlighted in the command window.
%   pagerankdemo - draw a 6-node web and compute its pagerank
%
% Directories:
%   shellgui        draw a pretty seashell
%   waitmex         use a waitbar in a C mexFunction
%   GEE             Gaussian Elimination Example
%   spok            "SParse OK": check if a sparse matrix is valid
%   find_components find connected components in an image
%   dimacs10        tools for accessing the DIMACS10 subset of matrices
%   Factorize       object-oriented x=A\b solver
%   SuiteSparseCollection    tools for managing the SuiteSparse Matrix Collection
%   spqr_rank       rank-determination, null space.  Les Foster, primary author
%
% Examples:
%   gipper              % add all files in current directory X to X.zip
%   hprintf (format, arg1, ...)     % fprint with links not highlighted
%   pagerankdemo        % run the pagerank demo
%   shellgui            % draw a pretty seashell
%   waitmex             % example mexFunction that creates a waitbar
%   find_commponents_example
%
% Copyright 2008-2012, Tim Davis, except for spqr_rank which is
% Copyright by Les Foster (San Jose State Univ) and Tim Davis.
% See the SPDX license identifier in each package.
